//    This file is part of RoadColoringImpl.
//
//    Copyright (C) 2008 Florian SIKORA sikora@univ-mlv.fr
//    http://igm.univ-mlv.fr/~fsikora/index.php?p=r
//
//    RoadColoringImpl is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    RoadColoringImpl is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    The complete GNU General Public Licence Notice can be found as the
//    `COPYING' file in the root directory.


package fr.umlv.roadcoloring.graph;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;

public class PrevNodes {


	private final List<Integer>[][] prevs;
	//private final Graph g;

	@SuppressWarnings("unchecked")
	public PrevNodes(Graph g, HashSet<Integer> ignoredNode) {
	//public PrevNodes(QuotientGraph g) {
		//this.g = g;
		prevs = new List[2][];

		prevs[Graph.REDEDGE] = new List[g.getSize()];
		prevs[Graph.BLUEEDGE] = new List[g.getSize()];

		for (int i=0 ; i<g.getSize() ; ++i) {
			prevs[Graph.REDEDGE][i] = new ArrayList<Integer>();
			prevs[Graph.BLUEEDGE][i] = new ArrayList<Integer>();
		}

		for(int u=0 ; u<g.getSize() ; ++u) {
			if (!ignoredNode.contains(u)) {
				//int clU = g.getNodeClass(u);

				prevs[Graph.REDEDGE][g.getRed(u)].add(u);
				prevs[Graph.BLUEEDGE][g.getBlue(u)].add(u);
				/*
				prevs[Graph.REDEDGE][g.getRed(clU)].add(clU);
				prevs[Graph.BLUEEDGE][g.getBlue(clU)].add(clU);
				 */
			}
		}
	}

	/*
	public void update(int changedNode) {
		int newBlue = g.getBlue(changedNode);

		//cast in Integer to remove Object, not by index
		prevs[Graph.REDEDGE][newBlue].remove((Integer)changedNode);
		prevs[Graph.BLUEEDGE][newBlue].add(changedNode);

		int newRed = g.getRed(changedNode);

		prevs[Graph.BLUEEDGE][newRed].remove((Integer)changedNode);
		prevs[Graph.REDEDGE][newRed].add(changedNode);
	}
	 */

	public List<Integer> getFromNode(int node) {
		List<Integer> ret = prevs[Graph.REDEDGE][node];
		ret.addAll(prevs[Graph.BLUEEDGE][node]);
		return ret;
	}

	public int getOnePred(int node, byte color) {
		if (prevs[color][node].size() > 0) return prevs[color][node].get(0);
		else return -1;
	}
	public List<Integer> getAllPred(int node, byte color) {
		if (prevs[color][node].size() > 0) return prevs[color][node];
		else return null;
	}
}
