//    This file is part of RoadColoringImpl.
//
//    Copyright (C) 2008 Florian SIKORA sikora@univ-mlv.fr
//    http://igm.univ-mlv.fr/~fsikora/index.php?p=r
//
//    RoadColoringImpl is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    RoadColoringImpl is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    The complete GNU General Public Licence Notice can be found as the
//    `COPYING' file in the root directory.


package fr.umlv.roadcoloring.graph;

/**
 * Class for manage a stable pair
 * the two node of this pair gone on the same node by red
 * they are in the same class 
 * 
 * stocked as a always the lower of the pair
 * 
 * @author fsikora
 *
 */

public class StablePair {
	private final int a;
	private final int b;

	public StablePair(int a, int b) {
		if (a < b) {
			this.a = a;
			this.b = b;
		}
		else if (a > b){
			this.b = a;
			this.a = b;
		}
		else {
			throw new IllegalArgumentException("Stable pair are the same node !");
		}
	}
	
	public int getA() {
		return a;
	}
	
	public int getB() {
		return b;
	}

	@Override
	public String toString() {
		return "("+a+ ", " + b + ")";
	}
}

